#include "pop3.h"
#include <cstdlib>
#include <iomanip>
#include <iostream>
#include <unistd.h>

using namespace std;

int main(int argc, char **argv) {
    char *hostname = NULL;
    char *username = NULL;
    char *password;
    int port = 0;
    char *id = NULL;

    int c;

    // process command-line arguments
    while ((c = getopt(argc, argv, "h:p:u:")) != -1) {
        switch (c) {
            case 'h':
                hostname = optarg;
                break;
            case 'p':
                port = atoi(optarg);
                break;
            case 'u':
                username = optarg;
                break;
        }
    }

    // hostname and username are required
    if (hostname == NULL || username == NULL) {
        cerr << "Not enough parameters were given." << endl;
        cout << "Usage: " << argv[0]
             << " -h hostname [-p port] -u username [id]" << endl;

        return EXIT_FAILURE;
    }

    // process the rest
    if (optind < argc) {
        id = argv[optind];
    }

    password = getpass("Enter your email password: ");

    try {
        pop3 p(hostname, username, password, port);
    
        if (id) {
            cout << p.retr(id) << endl;
        }
        else {
            cout << p.list() << endl;
        }
    } catch (runtime_error &e) {
        cerr << "Error: " << e.what() << "." << endl;
        return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}
